
// OPERATOR: -(LX,LX) ______________________________________

 template<typename ALX, typename BLX>
 friend
 vu2<typename decay<decltype(declval<ALX>()-
                             declval<BLX>() )
                   >::type
    >
 operator-(vu2<ALX> const& a, vu2<BLX> const& b)            ;

// OPERATOR: -(LX,RT) ______________________________________

 template<typename ALX, typename BRT>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ALX>()-
                                           declval<BRT>() )
                                 >::type,
                   typename decay<decltype(declval<BRT>() )
                                 >::type
                  >::value,
           vu2<typename     decay<decltype(declval<ALX>()-
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator-(vu2<ALX> const& a, vu2<BRT> && b)                ;

// OPERATOR: -(LX,RW) ______________________________________

 template<typename ALX, typename BRW>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ALX>()-
                                           declval<BRW>() )
                                 >::type,
                   typename decay<decltype(declval<BRW>() )
                                 >::type
                  >::value,
           vu2<typename     decay<decltype(declval<ALX>()-
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator-(vu2<ALX> const& a, vu2<BRW> && b)                ;

// OPERATOR: -(RT,LX) ______________________________________

 template<typename ART, typename BLX>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ART>()-
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ART>() )
                                 >::type
                  >::value,
           vu2<typename     decay<decltype(declval<ART>()-
                                           declval<BLX>() )
                                 >::type
              >
          >::type
 operator-(vu2<ART> && a, vu2<BLX> const& b)                ;

// OPERATOR: -(RW,LX) ______________________________________

 template<typename ARW, typename BLX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()-
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           vu2<typename     decay<decltype(declval<ARW>()-
                                           declval<BLX>() )
                                 >::type
              >
          >::type&&
 operator-(vu2<ARW> && a, vu2<BLX> const& b)                ;

// OPERATOR: -(RW,RX) ______________________________________

 template<typename ARW, typename BRX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()-
                                           declval<BRX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           vu2<typename     decay<decltype(declval<ARW>()-
                                           declval<BRX>() )
                                 >::type
              >
          >::type&&
 operator-(vu2<ARW> && a, vu2<BRX> && b)                    ;

// OPERATOR: -(RT,RW) ______________________________________

 template<typename ART, typename BRW>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()-
                                          declval<BRW>() )
                                >::type
                 >::value
                 &&
          is_same<typename decay<decltype(declval<BRW>() )
                                >::type,
                  typename decay<decltype(declval<ART>()-
                                          declval<BRW>() )
                                >::type
                 >::value,
           vu2<typename     decay<decltype(declval<ART>()-
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator-(vu2<ART> && a, vu2<BRW> && b)                    ;

// OPERATOR: -(RT,RT) ______________________________________

 template<typename ART, typename BRT>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()-
                                          declval<BRT>() )
                                >::type
                 >::value
                 &&
         !is_same<typename decay<decltype(declval<BRT>() )
                                >::type,
                  typename decay<decltype(declval<ART>()-
                                          declval<BRT>() )
                                >::type
                 >::value,
           vu2<typename     decay<decltype(declval<ART>()-
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator-(vu2<ART> && a, vu2<BRT> && b)                    ;

// OPERATOR: -=

 template<typename ALX, typename BLX>
 friend
   vu2<BLX>&
   operator-=(vu2<ALX>& a, vu2<BLX>& b)                     ;

 template<typename ALX, typename BRX>
 friend
   vu2<BRX>&&
   operator-=(vu2<ALX>& a, vu2<BRX> && b)                   ;

